% Implementation of the following paper:

% Rushi Lan and Yicong Zhou, Medical Image Retrieval via Histogram of
% Compressed Scattering Coefficients, accepted for publication in IEEE
% Journal of Biomedical and Health Informatics, 2016.

% for more information, please feel free to contact Rushi Lan (lrs0106@yahoo.com or rslan2012@gmail.com)

clear, clc, close all

%%% to run this demo, first you need to perform the scattering transform to each
%%% CT image, and save as: nema_ct_tip_1, ..., nema_ct_tip_315.

path0 = '\scatter_representation\nema_ct_tip\';
labels = dlmread([path0 'nema_ct_tip_labels.txt']);


codewords = dlmread('nema_ct_tip_codewords_3_200.txt');  
scatter_fea = [];
for i=1:315
    data = load([path0 'nema_ct_tip_' num2str(i)]);    % obtain the scattering representation of each CT image
    data = data.temp;
    temp_sig = data{1,3}.signal;
    word_ind = [];
    for j=1:length(temp_sig)
        coef = temp_sig{j};
        coef = double(coef);
        coef = sum(coef);    % Projection operation
        index = codeword_search(coef, codewords);
        word_ind(j) = index;
    end
    a = MyHist(word_ind,200);
    scatter_fea(i,:) = a/sum(a); 
end

[ARP ARR Fscore] = image_retrieval(scatter_fea, labels, 10, 'inter_sec')    % different dis can be considered: L1, L2, and inter_sec;





